

// -*- mode: c++; c-basic-offset:4 -*-

// (c) COPYRIGHT URI/MIT 2002
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//	Patrick West <pwest@ucar.edu>

#ifndef iterator_adapter_t_h
#define iterator_adapter_t_h

#ifdef __GNUG__
#pragma interface
#endif

#include <vector>
#include <IteratorAdapter.h>

#include <stdio.h>

template<class T>
class IteratorAdapterT : public IteratorAdapter
{
    public:
	/* constructor */
	IteratorAdapterT( std::vector<T> &vec ) ;

	/* destructor */
	virtual ~IteratorAdapterT( ) ;

	/* derived public methods */
	virtual void first( ) ;
	virtual void next( ) ;
	virtual operator bool( ) ;
	virtual bool operator==( const IteratorAdapter &i ) ;

	/* new public methods */
	T entry( ) ;
	typename std::vector<T>::iterator &getIterator( ) ;

    protected:

    private:
	/* private data members */
	std::vector<T> &_vec ;
	typename std::vector<T>::iterator _i ;
} ;

// $Log: IteratorAdapterT.h,v $
// Revision 1.1.4.6  2002/12/17 19:33:14  pwest
// Eliminated warnings of implicit typename for iter typedef and replaced with
// direct typename use.
//
// Revision 1.1.4.5  2002/12/05 20:36:19  pwest
// Corrected problems with IteratorAdapter code, making methods non-inline,
// creating source files and template instantiation file. Cleaned up file
// descriptors and memory management problems. Corrected problem in Connect
// where the xdr source was not being cleaned up or a new one created when a
// new file was opened for reading.
//
// Revision 1.1.4.4  2002/11/05 01:11:49  jimg
// Added some boilerplate and fiddled with formatting.
//

#endif // iterator_adapter_t_h
