
// -*- C++ -*-

// (c) COPYRIGHT URI 2000
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      reza            Reza Nekovei <reza@ieee.org>
//      jhrg,jimg       James Gallagher <jgallagher@gso.uri.edu>


#ifndef _translation_h
#define _translation_h 1

#ifdef __GNUG__
#pragma interface
#endif

class Translation {
private:
    DDS tdds;
    DDS dds;
    string accept_types;

    struct bt_pair {
	BaseType *orig;
	BaseType *trans;
    
	bt_pair(BaseType *o, BaseType *t) : orig(o), trans(t) {}
	~bt_pair() {}
	BaseType *original() {return orig;}
	BaseType *translated() {return trans;}
	void print(ostream &os) {
	    if (orig)
		os << orig->name();
	    else
		os << "null";
	    os << ": ";
	    if (trans) 
		os << trans->name();
	    else
		os << "null"; 
	    os << endl;
	}
    };

    vector<bt_pair> variable_mapping;

protected:  
    void remover();
    void flatstruc();
    void nogappygrid();
    void grid2seq();
    void array2seq();
    void grid2array();
    void seq2array();
    int get_trans_table();

    void TransType();

    void  add_variable_mapping(BaseType *orig, BaseType *trans);

public: 
    Translation(const DDS &dds, const string &accept_types);

    DDS& get_tdds();

    bool send_servers_data();
    BaseType *find_translated_var(BaseType *original);
    void copy_data(BaseType *src, BaseType *dest);
    void write_binary_data(const string &dataset, const string &cgi_ver, 
			   FILE *out);
    void print_variable_mapping(ostream &os);
};

#endif // _translation_h
